/*
 * Collisions 5000 Info - a logic puzzle game for PalmOS devices.
 * 
 * frmLevFinished.c ,v 1.00 2001/05/31 
 * Copyright (C) 2001, Graham Rowbottom
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
 
#include <PalmOS.h>
#include "Collisions5000.h"
#include "Collisions5000_res.h"   
#include "Bitmap.h"   


void levfinished_init();

static Boolean frmLevFinished_frmLevFinished_CmdLoad_OnSelect(EventPtr event)
{
	// Insert code for frmLevFinished_CmdLoad
	FrmGotoForm(frmLoadLevel);
	return true;
}

static Boolean frmLevFinished_nextlevel_OnSelect(EventPtr event)
{
	// Insert code for nextlevel
	if (gameState != NULL)
	{
		if (gameState->level != NULL)
		{
			FormPtr mainform;
			int curIndex = gameState->level->index;
			destroyCurrentLevel();
		
			// safe since this button is disabled if we are
			// already on the last level (in init()).
			if (gameBullets != NULL)
				MemPtrFree(gameBullets);
				gameBullets = NULL;
			
			if (nextTurnAdd != NULL)	
				MemPtrFree(nextTurnAdd);
				nextTurnAdd = NULL;
				
			//FrmEraseForm(mainform = FrmGetFormPtr(frmMain));
			//FrmDeleteForm(mainform);
			FrmReturnToForm(frmMain);
			
			runLevel(LEVELS_DB_NAME, LEVELS_DB_TYPE, ++curIndex);
		}
	}
	return true;
}

Boolean frmLevFinished_HandleEvent(EventPtr event)
{
	FormPtr form;
	Boolean handled = false;

	switch (event->eType)
	{
		case ctlSelectEvent:
			switch (event->data.ctlSelect.controlID)
			{
				// frmLevFinished_CmdLoad receives an event
				case frmLevFinished_CmdLoad:
					handled = frmLevFinished_frmLevFinished_CmdLoad_OnSelect(event);
					break;
				// loadtrig receives an event
				// nextlevel receives an event
				case frmLevFinished_CmdNext:
					handled = frmLevFinished_nextlevel_OnSelect(event);
					break;
			}
			break;
		
			
		case frmOpenEvent:
			// Repaint form on open
			form = FrmGetActiveForm();
			FrmDrawForm(form);
			levfinished_init();
			handled = true;
			break;
		default:
			break;
	}

	return handled;
}

void levfinished_init()
{
	FormPtr form = FrmGetActiveForm();
	
	// first see if this is the last level. if so, remove the 'next level' option
	if (gameState != NULL)
		if (gameState->level != NULL)
		{
			int curIndex = gameState->level->index;
			if (DatabaseAccess_openDB(LEVELS_DB_NAME, LEVELS_DB_TYPE, &m_db))
			{
				if (curIndex == DmNumRecords(m_db)-1)
				{
					FrmHideObject(form, FrmGetObjectIndex(form, frmLevFinished_CmdNext));			
				}
				
				DmCloseDatabase(m_db);
			}	
		}
	
	// next, load the level names into this popup list	
	//loadLevels(frmLevFinished_LoadList);
	
	// finally, since we finished the level - remove the status level so
	// if we quit now, we'll start back at the main menu screen
	if (DatabaseAccess_openDB(STATUS_DB_NAME, STATUS_DB_TYPE, &m_db))
	{
		if (DmNumRecords(m_db) > 0)
			DmRemoveRecord(m_db, 0);
			
		DmCloseDatabase(m_db);
	}
	
}
